<?php

/*
+---------------------------------------------------------------------------+
| Max Media Manager v0.3                                                    |
| =================                                                         |
|                                                                           |
| Copyright (c) 2003-2006 m3 Media Services Limited                         |
| For contact details, see: http://www.m3.net/                              |
|                                                                           |
| This program is free software; you can redistribute it and/or modify      |
| it under the terms of the GNU General Public License as published by      |
| the Free Software Foundation; either version 2 of the License, or         |
| (at your option) any later version.                                       |
|                                                                           |
| This program is distributed in the hope that it will be useful,           |
| but WITHOUT ANY WARRANTY; without even the implied warranty of            |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
| GNU General Public License for more details.                              |
|                                                                           |
| You should have received a copy of the GNU General Public License         |
| along with this program; if not, write to the Free Software               |
| Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA |
+---------------------------------------------------------------------------+
$Id: DaySpan.php 4346 2006-03-06 16:43:19Z andrew@m3.net $
*/

/**
 * Report field factory class for Max Media Manager
 *
 * @package    Max
 * @author     Scott Switzer <scott@switzer.org>
 * @TODO This should be a replacement for the DateRange class
 */
require_once MAX_PATH . '/lib/max/Admin/UI/Field/TextField.php';
require_once MAX_PATH . '/lib/max/Admin/UI/Field/CampaignSelectionField.php';
require_once MAX_PATH . '/lib/max/Admin/UI/Field/AdvertiserIdField.php';
require_once MAX_PATH . '/lib/max/Admin/UI/Field/PublisherIdField.php';
require_once MAX_PATH . '/lib/max/Admin/UI/Field/TrackerField.php';
require_once MAX_PATH . '/lib/max/Admin/UI/Field/ZoneIdField.php';
require_once MAX_PATH . '/lib/max/Admin/UI/Field/ZoneScopeField.php';
require_once MAX_PATH . '/lib/max/Admin/UI/Field/DateRangeField.php';
require_once MAX_PATH . '/lib/max/Admin/UI/Field/DropdownField.php';
//require_once MAX_PATH . '/lib/max/Admin/Reporting/Field/DateRangeSelectorField.php';
require_once MAX_PATH . '/lib/max/Admin/UI/Field/OrganisationSelectionField.php';

class FieldFactory
{
    /**
     *  Creates a new Field object of the appropriate subclass.
     * @param string $field_type The type of field to create.
     */
    function &newField($fieldType)
    {
        switch ($fieldType) {
            case 'edit' :                 $field = new Admin_UI_TextField(); break;
            case 'campaignid-dropdown' :  $field = new Admin_UI_CampaignSelectionField(); break;
            case 'clientid-dropdown' :    $field = new Admin_UI_AdvertiserIdField(); break;
            case 'advertiser' :           $field = new Admin_UI_AdvertiserIdField(); break;
            case 'affiliateid-dropdown' : $field = new Admin_UI_PublisherIdField(); break;
            case 'publisher' :            $field = new Admin_UI_PublisherIdField(); break;
            case 'trackerid-dropdown' :   $field = new Admin_UI_TrackerField(); break;
            case 'zoneid-dropdown' :      $field = new Admin_UI_ZoneIdField(); break;
            case 'zone-scope' :           $field = new Admin_UI_ZoneScopeField(); break;
            case 'date-range' :           $field = new Admin_UI_DateRangeField(); break;
            case 'date-month' :           $field = new Admin_UI_DateRangeField(); break;
            case 'dropdown' :             $field = new Admin_UI_DropdownField(); break;
            case 'date-range-selector' :  $field = new Admin_UI_DateRangeField(); break;
            case 'scope' :                $field = new Admin_UI_OrganisationSelectionField(); break;
            case 'scope-tracker' :        $field = new Admin_UI_OrganisationSelectionField(); $field->_filter = FILTER_TRACKER; break;
            default :                     MAX::raiseError("The report module discovered a field type that it didn't know how to handle.", MAX_ERROR_INVALIDARGS);
        }
        return $field;
    }
}

?>
